<?php
/**
 * ApiV1TanssEventsRulesAssignments
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * ApiV1TanssEventsRulesAssignments Class Doc Comment
 *
 * @category Class
 * @description Defines an assignment from a TANSS event rule to an assignment (i.e. Ticket Board Panel)
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class ApiV1TanssEventsRulesAssignments implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = '_api_v1_tanssEvents_rules_assignments';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'linkType' => 'string',
        'linkId' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'linkType' => null,
        'linkId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'linkType' => 'linkType',
        'linkId' => 'linkId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'linkType' => 'setLinkType',
        'linkId' => 'setLinkId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'linkType' => 'getLinkType',
        'linkId' => 'getLinkId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const LINK_TYPE_PC = 'PC';
    public const LINK_TYPE_COMPANY = 'COMPANY';
    public const LINK_TYPE_EMPLOYEE = 'EMPLOYEE';
    public const LINK_TYPE_PERIPHERY = 'PERIPHERY';
    public const LINK_TYPE_COMPONENT = 'COMPONENT';
    public const LINK_TYPE_SOFTWARELICENSE = 'SOFTWARELICENSE';
    public const LINK_TYPE_SUPPORT = 'SUPPORT';
    public const LINK_TYPE_VOUCHER = 'VOUCHER';
    public const LINK_TYPE_DOCUMENT = 'DOCUMENT';
    public const LINK_TYPE_DOCUMENT_S2_T = 'DOCUMENT_S2T';
    public const LINK_TYPE_TICKET = 'TICKET';
    public const LINK_TYPE_KNOWLEDGE_BASE = 'KNOWLEDGE_BASE';
    public const LINK_TYPE_PERMISSION = 'PERMISSION';
    public const LINK_TYPE_PERMISSION_PACKAGE = 'PERMISSION_PACKAGE';
    public const LINK_TYPE_GROUP = 'GROUP';
    public const LINK_TYPE_CALLBACK = 'CALLBACK';
    public const LINK_TYPE_CONSULTATION = 'CONSULTATION';
    public const LINK_TYPE_SLA = 'SLA';
    public const LINK_TYPE_CONTRACT = 'CONTRACT';
    public const LINK_TYPE_PREPAID_PURCHASE = 'PREPAID_PURCHASE';
    public const LINK_TYPE_EVENT = 'EVENT';
    public const LINK_TYPE_FILE_LINKS = 'FILE_LINKS';
    public const LINK_TYPE_BIRTHDAY = 'BIRTHDAY';
    public const LINK_TYPE_DOMAIN = 'DOMAIN';
    public const LINK_TYPE_TEAMVIEWER = 'TEAMVIEWER';
    public const LINK_TYPE_REMOTE_SUPPORT = 'REMOTE_SUPPORT';
    public const LINK_TYPE_DOCUSNAP = 'DOCUSNAP';
    public const LINK_TYPE_MATERIAL = 'MATERIAL';
    public const LINK_TYPE_CHAT = 'CHAT';
    public const LINK_TYPE_TODO = 'TODO';
    public const LINK_TYPE_DOCUSNAP_SNMP = 'DOCUSNAP_SNMP';
    public const LINK_TYPE_VACATION_REQUEST = 'VACATION_REQUEST';
    public const LINK_TYPE_TICKET_BOARD_PANEL = 'TICKET_BOARD_PANEL';
    public const LINK_TYPE_DEPARTMENT = 'DEPARTMENT';
    public const LINK_TYPE_COMPANY_TYPE = 'COMPANY_TYPE';
    public const LINK_TYPE_TICKET_TYPE = 'TICKET_TYPE';
    public const LINK_TYPE_MAIL = 'MAIL';
    public const LINK_TYPE_OFFER = 'OFFER';
    public const LINK_TYPE_TICKET_STATE = 'TICKET_STATE';
    public const LINK_TYPE_OVERTIME_ADDITIONAL_CHARGE = 'OVERTIME_ADDITIONAL_CHARGE';
    public const LINK_TYPE_CHECKLIST = 'CHECKLIST';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLinkTypeAllowableValues()
    {
        return [
            self::LINK_TYPE_PC,
            self::LINK_TYPE_COMPANY,
            self::LINK_TYPE_EMPLOYEE,
            self::LINK_TYPE_PERIPHERY,
            self::LINK_TYPE_COMPONENT,
            self::LINK_TYPE_SOFTWARELICENSE,
            self::LINK_TYPE_SUPPORT,
            self::LINK_TYPE_VOUCHER,
            self::LINK_TYPE_DOCUMENT,
            self::LINK_TYPE_DOCUMENT_S2_T,
            self::LINK_TYPE_TICKET,
            self::LINK_TYPE_KNOWLEDGE_BASE,
            self::LINK_TYPE_PERMISSION,
            self::LINK_TYPE_PERMISSION_PACKAGE,
            self::LINK_TYPE_GROUP,
            self::LINK_TYPE_CALLBACK,
            self::LINK_TYPE_CONSULTATION,
            self::LINK_TYPE_SLA,
            self::LINK_TYPE_CONTRACT,
            self::LINK_TYPE_PREPAID_PURCHASE,
            self::LINK_TYPE_EVENT,
            self::LINK_TYPE_FILE_LINKS,
            self::LINK_TYPE_BIRTHDAY,
            self::LINK_TYPE_DOMAIN,
            self::LINK_TYPE_TEAMVIEWER,
            self::LINK_TYPE_REMOTE_SUPPORT,
            self::LINK_TYPE_DOCUSNAP,
            self::LINK_TYPE_MATERIAL,
            self::LINK_TYPE_CHAT,
            self::LINK_TYPE_TODO,
            self::LINK_TYPE_DOCUSNAP_SNMP,
            self::LINK_TYPE_VACATION_REQUEST,
            self::LINK_TYPE_TICKET_BOARD_PANEL,
            self::LINK_TYPE_DEPARTMENT,
            self::LINK_TYPE_COMPANY_TYPE,
            self::LINK_TYPE_TICKET_TYPE,
            self::LINK_TYPE_MAIL,
            self::LINK_TYPE_OFFER,
            self::LINK_TYPE_TICKET_STATE,
            self::LINK_TYPE_OVERTIME_ADDITIONAL_CHARGE,
            self::LINK_TYPE_CHECKLIST,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['linkType'] = $data['linkType'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getLinkTypeAllowableValues();
        if (!is_null($this->container['linkType']) && !in_array($this->container['linkType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'linkType', must be one of '%s'",
                $this->container['linkType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets linkType
     *
     * @return string|null
     */
    public function getLinkType()
    {
        return $this->container['linkType'];
    }

    /**
     * Sets linkType
     *
     * @param string|null $linkType Enum representing the \"link type\" of an assignment. The id is given in the field \"linkId\"
     *
     * @return self
     */
    public function setLinkType($linkType)
    {
        $allowedValues = $this->getLinkTypeAllowableValues();
        if (!is_null($linkType) && !in_array($linkType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'linkType', must be one of '%s'",
                    $linkType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['linkType'] = $linkType;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId id of the assignment
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


